#include <string.h>
#include <unistd.h>

int dowrite(int fd, const void *buf, size_t nbyte) {
    int ret, n = nbyte;
    const char *cbuf = buf;
    /* solange write() aufrufen, bis alle Daten geschrieben sind */
    do {
	ret = write(fd, cbuf, nbyte);
	cbuf += ret;	/* Adresse erhoehen um Anzahl der geschr. Bytes */
	nbyte -= ret;	/* und Anzahl zu schreibender Bytes entspr. verringern */
    } while (ret > 0 && nbyte > 0);
    return ret < 0 ? ret : n;
}

int main() {
    char *s = "Hallo Welt!";
    int len = strlen(s);

    /* Ausgabe von s mit abschliessendem Newline aus stdout */
    dowrite(1, s, len);
    dowrite(1, "\n", 1);

    return 0;
}
